Subject: Re: [Json] Normative reference reasoning and logistics

From: "Joe Hildebrand (jhildebr)" <[email-masked]>
Date: Thu, 28 Apr 2016 17:06:22 +0000

Going back to an earlier point in the thread:

On 11/14/15, 11:10 AM, "Tim Bray" <[email-masked]> wrote:

>So, is there a *real* reason why a normative reference might be useful? I think there might be, and it's purely rhetorical (in the formal sense, designed to support an argument): To make it clear to the world
> that all JSON is the same JSON no matter where it's specified.  So I think it would be plausible to add the following to the second paragraph of section 1.2 of 7159 (for convenience:
>http://rfc7159.net/rfc7159#rfc.section.1.2 ):
>
>“The reference to ECMA-404 in the previous sentence is normative, not with the usual meaning that implementors need to consult it in order to understand this document, but to emphasize that there are no inconsistencies in the definition of the term “JSON text” in any of its specifications. Note, however, that ECMA-404 allows several practices which this specification recommends avoiding in the interests of maximal interoperability.”

I like this text a lot.  Adding a few more points would be useful, I believe:

- The intent is that the grammar is the same between the two documents, although different descriptions are used.  If there a difference is found between them, ECMA and the IETF will work together to update both documents.

- If an error is found with either document, the other should be examined to see if it has a similar error, and fixed if possible.

- If either document is changed in the future, ECMA and the IETF will work together to ensure that the two documents stay aligned through the change.

There is liaison work to do to ensure that ECMA-404bis has similar language, but I wouldn't have any problem with us publishing a 7159bis draft that included language like this before ECMA is fully onboard.

-- 
Joe Hildebrand